function tag = isstained(P)
% This functions tests a patch P of beeing a stained patch or not. The
% patch is a RGB image (NxMx3 matrix) and consists of the cell nucleus in
% the middle.
%

% take a sub image: middle square of the patch (to leave out the
% environmend)
h = size(P, 1);
w = size(P, 2);
xmin = round(3*w/8);
ymin = round(3*h/8);
h = round(h/4);
w = round(w/4);
rect = [xmin, ymin, w-1, h-1];
P = imcrop(P, rect);

% if the mean of red in this subimage is greater than the mean of blue,
% the image is stainded
R = P(:,:,1);
G = P(:,:,2);
B = P(:,:,3);
tag = (mean(mean(R))+mean(mean(G)))/2 > mean(mean(B)) || ...
       mean(mean(R)) > mean(mean(B));
