function chain = lbp(P, asHistogram, numbins)
% This function calculates the Local Binary Pattern feature for a given
% patch P.
%
% P: A gray scale image
%
% asHistogram: if false, the lbp is returned directly. 
% If true, a histogram over the lbp is returned.
% 
% numbins: Number of bins for the histogram. Only needed if asHistogram
% is true.

% Add path
if (~isdeployed)
addpath('/cluster/home/infk/peschuef/MATLAB/');
addpath('/cluster/home/infk/peschuef/MATLAB/fdtool/');
end;

%P = uint8(P);
%disp(class(P));
%disp(P);
try
    N = 8; % see the 8 neighbours of a pixel
    R = 1; % Radius 1, direct neighbour pixels
    mapping = getmapping(N, 'u2'); % u2 for uniform (chainlength 59)
    %mapping = getmapping(N, 'ri'); % ri for rotational invariant (chainlength 36)
    %mapping = getmapping(N, 'riu2'); % riu2 for rotational invariant and uniform (10)
    map = mapping.table;
    chain = chlbp(P ,N ,R ,map')';
    chain = double(chain);
catch exception
    disp('Exception in LBP');
    chain = zeros(1,59);
end;

if (asHistogram)
    chain = hist(chain, numbins);
end;

end