function points_struct=read_svg(filename)
%function points_struct=read_svg(filename)
% this function read an svg file and returns points and titles
% points_struct
% points_struct: is a structure array with size of the number of blobs in
% the svg file
%filename: is the name and the directory path of the svg file 
lit_points='points=';
lit_title='<title>';
lit_endtitle='</title>';
lit_quotation='"';
lit_comma=',';
lit_polyline='<polyline';
lit_smaller='<';
lit_greater='>';

fid=fopen(filename);
% 
% matches_points=[];
% matches_title=[];
% matches_endtitle=[];
% matches_quotation=[];
% matches_comma=[];
% mathches_polyline=[];
% matches_smaller=[];
% matches_greater=[];

k=0;
points=[];
% putting the point in the structure array "points";
while feof(fid)==0
   tline = fgetl(fid);
   matches_points = findstr(tline,lit_points);
   matches_title = findstr(tline,lit_title);  
   matches_endtitle = findstr(tline,lit_endtitle);   
   matches_quotation = findstr(tline,lit_quotation);   
%   matches_comma = findstr(tline,lit_comma);
%   matches_polyline=findstr(tline,lit_polyline);
%   matches_smaller=findstr(tline,lit_smaller);
%   matches_greater=findstr(tline,lit_greater);

   % assigning the title to the k-th element
   if length(matches_title)==length(matches_endtitle)
      nBlobs=length(matches_title);
      if  length(matches_title)~=length(matches_points)    
        %warning('broken XML file: the number of <title> tags do not match the number of "points" attributes in the <polyline> tags'); 
      end
   else
        warning('broken XML file: the number of <title> tags do not match to the number of </title> tags');
   end
   matches_endtitle=cat(2,1,matches_endtitle,length(tline));
   matches_title=cat(2,1,matches_title,length(tline));
   matches_points=cat(2,1,matches_points,0);
   %****** creating points structure array
   kk=2;
   for i=2:nBlobs+1
       points_title=findstr(tline(matches_title(i-1):matches_title(i)),lit_points);
       nPinT=length(points_title);
       if nPinT>1 
           warning('broken XML file: extra points attribute');
       end
       kk=kk+nPinT;
       if (matches_points(kk) > matches_endtitle(i)) && (matches_endtitle(i+1)> matches_points(kk))
           k=k+1;
       else
           continue;
       end    
       points_struct(k).title=str2num(tline(matches_title(i)+7:matches_endtitle(i)-1))+1;
       ind_points=matches_points(kk);
       ind_quot_i=find(matches_quotation==ind_points+7);
       points_string=tline(matches_quotation(ind_quot_i)+1:matches_quotation(ind_quot_i+1)-1);
       points_num=ceil(abs(str2num(points_string))+0.1);
       points_num=points_num(:);
       points_struct(k).points=reshape(points_num(1:2*floor(length(points_num)/2)),2,floor(length(points_num)/2));
       %k=k+1;
   end
end
%point_struct=points;
fclose(fid);
